org.eclipse.graphiti.ui.editor

## Class DefaultPaletteBehavior

- java.lang.Object
- - org.eclipse.graphiti.ui.editor.DefaultPaletteBehavior

    public class DefaultPaletteBehavior
    extends Object

This class can be subclassed by clients to adapt the palette appearance and behavior of the Graphiti diagram Editor. The API is very much aligned with the way GEF handles the palette within its editors, see `GraphicalEditorWithFlyoutPalette` for more information on that. To exchange the default implementation you have to return an instance of your subclass in the method `DiagramBehavior.createPaletteBehaviour()`.
Note that there is always a 1:1 relation with a `DiagramBehavior`.

Since:
  0.9

### Constructor Summary

Constructors
Constructor and Description
`DefaultPaletteBehavior(DiagramBehavior diagramBehavior)` Creates a new standard palette behaviour for a Graphiti diagram editor.

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `dispose()` Disposes this instance.
`org.eclipse.gef.ui.palette.FlyoutPaletteComposite.FlyoutPreferences` `getPalettePreferences()` Returns the Graphiti specific preferences for the palette.
`org.eclipse.gef.palette.PaletteRoot` `getPaletteRoot()` Returns the already existing `PaletteRoot` instance for the `DiagramBehavior` associated the this palette behavior or creates a new `PaletteRoot` instance in case none exists.
`void` `initializeViewer()` Initializes the used GEF palette viewer to display the palette as defined.
`void` `refreshPalette()` Refreshes the palette.

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### DefaultPaletteBehavior

    public DefaultPaletteBehavior(DiagramBehavior diagramBehavior)

Creates a new standard palette behaviour for a Graphiti diagram editor. The passed `DiagramBehavior` is closely linked to this instance (1:1 relation) and both instances will have a common lifecycle.

Parameters:
  `diagramEditor` - The associated `DiagramBehavior`.
Since:
  0.10

### Method Detail

#### getPaletteRoot

    public org.eclipse.gef.palette.PaletteRoot getPaletteRoot()

Returns the already existing `PaletteRoot` instance for the `DiagramBehavior` associated the this palette behavior or creates a new `PaletteRoot` instance in case none exists.

Returns:
  a new Graphiti specific `PaletteRoot` instance

#### initializeViewer

    public void initializeViewer()

Initializes the used GEF palette viewer to display the palette as defined. The default implementation initializes the preference store with the GEF `DefaultPaletteViewerPreferences` and triggers a refresh of the palette.

#### getPalettePreferences

    public org.eclipse.gef.ui.palette.FlyoutPaletteComposite.FlyoutPreferences getPalettePreferences()

Returns the Graphiti specific preferences for the palette. This method will be called by the GEF `GraphicalEditorWithFlyoutPalette` during initialization.

Returns:
  a Graphiti specific instanceof `FlyoutPaletteComposite.FlyoutPreferences`.

#### refreshPalette

    public void refreshPalette()

Refreshes the palette.

#### dispose

    public void dispose()

Disposes this instance. Must be called before closing the associated Graphiti diagram editor. The default implementation clears the `paletteRoot` reference.